/* Home/Strata/rep332/genweyl332.c */

#include <stdio.h>

#define A 3 
#define B 2
#define C 18
#define S1 6
#define S2 2
#define S 72

void makeweyl332(int t1[A],int t2[A],int t3[B],int t4[C])

{

  int l,m,n;
  
  for(l=0; l<B; l++)
    for(m=0; m<A; m++)
	for(n=0; n<A; n++)
          t4[9*l+3*m+n] = 9*t3[l]+3*t2[m]+t1[n];      
}


int main()
{

  int s1[S1][A],s2[S1][A],s3[S2][B],t4[S][C],i,j,k,l;

  s3[0][0]=0; s3[0][1]=1; s3[1][0]=1; s3[1][1]=0;
  /* elements of Z/2Z */
  
  #include "../lib/C/sym3.c"
  #include "../lib/C/sym3b.c"
      
  l=0;
  for(k=0; k<S2; k++)
    for(j=0; j<S1; j++)
       for(i=0; i<S1; i++) {
	 makeweyl332(s1[i],s2[j],s3[k],t4[l]);	l++; }
  
  for(j=0; j<S; j++)  {
    for(i=0; i<6; i++)
	printf("s[%d][%d]=%d; ",j,i,t4[j][i]);
    printf("\n");  
    for(i=6; i<12; i++) 
	printf("s[%d][%d]=%d; ",j,i,t4[j][i]);
    printf("\n");
    for(i=12; i<18; i++)
	printf("s[%d][%d]=%d; ",j,i,t4[j][i]);
    printf("\n"); }
}
