/* http://www001.upp.so-net.ne.jp/isaku/zcode/comb.c.html  */

#define DM 80 /* large enough number */
#define RK 10 /* large enough number */

int  DataA[RK][DM];
int  DataB[RK][DM];
int  COMB[DM][RK];


void sort(int v[R],int w[R])

{
int i,j,k;

 for(i=0; i<R; i++)
   w[i]=v[i];
 
 for(i=0; i<R; i++)
   for(j=i+1; j<R; j++)
     if(w[i]>w[j]) {
       k= w[i]; w[i]= w[j]; w[j]= k; }
}


void InitComb(int n,int r)  {
    int i,j;

    for(i=0; i<=n; i++)
      for(j=0; j<=r; j++)
	  COMB[i][j]=0;   /* Initalizing COMB  */

    for(i=1; i<n+1; i++)  {
      COMB[i][0]=1; COMB[i][i]=1; 
      for(j=1; j<i; j++)
	COMB[i][j]=COMB[i-1][j]+COMB[i-1][j-1]; }

    for(i=0; i<=n; i++)
      for(j=0; j<r; j++) {
	DataA[j][i]=0;  DataB[j][i]=0;   }
	    		   
    for(i=0; i<r; i++)
      for(j=i; j<=n-r+i; j++)
	DataA[i][j]=COMB[n-i-1][r-i]-COMB[n-j-1][r-i];

    for(i=0; i<r; i++)
      for(j=i; j<=n-r+i+1 ; j++)
	DataB[i][j]=COMB[n-i][r-i]-COMB[n-j][r-i]; 
}


int  CombN(int* v) {
  int i; int n=0; int w[R];

  sort(v,w);
    for (i=0; i<R; i++) n = n+DataA[i][w[i]];
    return n;
}


void NComb(int m,int* v) {
  int i,j;

  for (i=0; i<R; i++)    {
      j=i;
      for(j=i; DataB[i][j]<=m; ++j); 
      m=m-DataA[i][j-1]; v[i]=j-1;    }
} 




	      
