#include <stdio.h>

#define R 2

#include "../lib/C/comb.c"

#define A 6 
#define B 2
#define C 30
#define S1 720
#define S2 2
#define S 1440
#define N1 15

void makeweyl62(t1,t2,t3)
  int t1[A],t2[B],t3[C];

{

  int v[2],w[2],l,m,n;
  InitComb(6,2);
  
  for(l=0;l<B;l++)  
      for(m=0;m<N1;m++)	{
	NComb(m,v);
	  w[0]=t1[v[0]];
	  w[1]=t1[v[1]];
	  n=CombN(w);
	  t3[N1*l+m]=N1*t2[l]+n;	}
}


int main()
{
  
  int s1[S1][A],s2[S2][B],t3[S][C],i,j,k;

  #include "../lib/C/sym6.c"

  s2[0][0]=0; s2[0][1]=1; s2[1][0]=1; s2[1][1]=0;
  
  k=0;
  for(j=0;j<S2;j++)
    for(i=0;i<S1;i++)  {
      makeweyl62(s1[i],s2[j],t3[k]);
      k++;    }
  
  for(k=0; k<S; k++)  {
    for(i=0; i<C; i++)  {
	printf("s[%d][%d]=%d; ",k,i,t3[k][i]);  }
    printf("\n");  }
}
